package zxscanwrapper;

import eu.livotov.labs.android.camview.ScannerLiveView;
import android.content.Context;
import android.graphics.Bitmap;
import android.graphics.drawable.Drawable;
import android.util.DisplayMetrics;
import android.view.ViewGroup;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BA.Author;
import anywheresoftware.b4a.BA.Hide;
import anywheresoftware.b4a.BA.Pixel;
import anywheresoftware.b4a.BA.ShortName;
import anywheresoftware.b4a.BA.Version;
import anywheresoftware.b4a.BALayout;
import anywheresoftware.b4a.keywords.Common.DesignerCustomView;
import anywheresoftware.b4a.objects.LabelWrapper;
import anywheresoftware.b4a.objects.PanelWrapper;
import anywheresoftware.b4a.objects.ViewWrapper;
import anywheresoftware.b4a.BA.Events;
import anywheresoftware.b4a.BA.ActivityObject;
import anywheresoftware.b4a.BA.DependsOn;
import android.view.MotionEvent;
import android.view.MotionEvent;

import android.view.View;
import android.view.View.OnClickListener;
import android.view.View.OnLongClickListener;
import android.view.View.OnTouchListener;
import android.view.ViewParent;

import android.graphics.BitmapShader;
import android.graphics.Shader;
import android.graphics.drawable.ShapeDrawable;
import android.graphics.drawable.shapes.RectShape;

import eu.livotov.labs.android.camview.CameraLiveView;
import eu.livotov.labs.android.camview.camera.CameraManager;
import eu.livotov.labs.android.camview.camera.CameraController;
import eu.livotov.labs.android.camview.camera.CameraDelayedOperationResult;
import eu.livotov.labs.android.camview.camera.CameraInfo;

import android.widget.Toast;

import java.io.IOException;
import java.util.Collection;

@Events(values={"scanner_started()","scanresult()","scanner_stopped()", "scan_error()"})
@Author("Github: Dmitri Livotov, Wrapper: Johan Schoeman")
@Version(1.00f)
@ShortName("zxScannerLiveView")
@ActivityObject
@DependsOn(values={"android-support-v4", "core-3.1.0"})
public class zxScanWrapper extends ViewWrapper<ScannerLiveView> implements DesignerCustomView {


	private BA ba;
	private String eventName;
        private ScannerLiveView cv;
        private CameraController controller;
        private boolean flashStatus;
        private String scanresult = "";
        private boolean scannerOn = false;
        private boolean flashOn = false;
        public String FRONT = "FRONT";
        public String BACK = "BACK";
        public String mfrontOrBack = "BACK";

 
	
	/*
	 * Initialize the HTML-TextView 
	 */   


	
	public void Initialize(BA ba, String EventName) {
		_initialize(ba, null, EventName);
	}

	@Hide
	public void _initialize(BA ba, Object activityClass, String EventName) {
		this.eventName = EventName.toLowerCase(BA.cul);
		this.ba = ba;
		cv = new ScannerLiveView(ba.context);
                this.setObject(cv);
                addListener();
 	}


//    @Hide
//    public void addListener(){
//        cv.setCallback(new RippleView.Callback() {
//            @Override
//            public void complete() {

//              if (ba.subExists(eventName + "_complete")) {
//                ba.raiseEvent2(ba, false, eventName + "_complete", true, new Object[0]);
//              }
//            }

//            @Override
//            public void started() {

//              if (ba.subExists(eventName + "_started")) {
//                ba.raiseEvent2(ba, false, eventName + "_started", true, new Object[0]);
//              }
//            }


//        });
//    }


	//programmatically add view
        @Hide
	public void AddToParent(ViewGroup Parent, @Pixel int left, @Pixel int top, @Pixel int width, @Pixel int height) {
		Parent.addView(cv, new BALayout.LayoutParams(left, top, width, height));
	}
	
	//this method cannot be hidden.
  
        
	public void DesignerCreateView(PanelWrapper base, LabelWrapper lw, anywheresoftware.b4a.objects.collections.Map props) {
		ViewGroup vg = (ViewGroup) base.getObject().getParent();
		AddToParent(vg, base.getLeft(), base.getTop(), base.getWidth(), base.getHeight());
		base.RemoveView();
		//set text properties
	}

	public void setLeft(int left)	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		lp.left = left;
		cv.getParent().requestLayout();
	}

	public int getLeft()	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		return lp.left;
	}
	public void setTop(int top)	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		lp.top = top;
		cv.getParent().requestLayout();
	}
 
	public int getTop()	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		return lp.top;
	}
	
	public void setWidth(int Width)	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		lp.width = Width;
		cv.getParent().requestLayout();
	}

	public int getWidth()	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		return lp.width;
	}
	
	public void setHeight(int height)	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		lp.height = height;
		cv.getParent().requestLayout();
	}

	public int getHeight()	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		return lp.height;
	}


    /**
     * Starts scanner, using device default camera
     */
    public void startScanner() {

        Collection<CameraInfo> cams = cv.getAvailableCameras();
        CameraInfo frontFacingCamera = null;

        for (CameraInfo cam : cams)
        {
            if (cam.isFrontFacingCamera())
            {
                frontFacingCamera = cam;
                break;
            }
        }
    
        if ((frontFacingCamera!=null) && (mfrontOrBack == "FRONT"))
        {
            cv.startScanner(frontFacingCamera);
        } else
        {
            cv.startScanner();
        }




//        cv.startScanner();
    }

        @Hide
        public void addListener() {


            cv.setOnClickListener(new View.OnClickListener() {
                @Override
                public void onClick(View v) {
                    if (scannerOn) toggleFlash();
//                  BA.Log("HERE");
                }
            });



            cv.setScannerViewEventListener(new ScannerLiveView.ScannerViewEventListener() {
            @Override
            public void onScannerStarted(ScannerLiveView scanner)
            {
                scannerOn = true;
                if (ba.subExists(eventName + "_scanner_started")) {
                  ba.raiseEvent2(ba, false, eventName + "_scanner_started", true, new Object[0]);
                }
            }

            @Override
            public void onScannerStopped(ScannerLiveView scanner)
            {
                scannerOn = false;
                if (ba.subExists(eventName + "_scanner_stopped")) {
                  ba.raiseEvent2(ba, false, eventName + "_scanner_stopped", true, new Object[0]);
                }
            }

            @Override
            public void onScannerError(Throwable err)
            {
                if (ba.subExists(eventName + "_scan_error")) {
                  ba.raiseEvent2(ba, false, eventName + "_scan_error", true, new Object[0]);
                }
            }

            @Override
            public void onCodeScanned(String data) {
                scanresult = data;
                if (ba.subExists(eventName + "_scanresult")) {
                  ba.raiseEvent2(ba, false, eventName + "_scanresult", true, new Object[0]);
                }
            }
        });

        }

    public void toggleFlash() {
        if (flashOn == false) {
            flashOn = true;
        } else {
           flashOn = false;
        }
        flashStatus = !flashStatus;
        cv.getCamera().getController().switchFlashlight(flashStatus);
    }

    public void setPlaySound(boolean playSound) {
        cv.setPlaySound(playSound);
    }

    public void setHudVisible(boolean visible) {
        cv.setHudVisible(visible);
    }

    /**
     * Stops currently running scanner
     */
    public void stopScanner() {
        if (flashOn == true) {
          toggleFlash();
          flashOn = false;
          scannerOn = false;
        }
        cv.stopScanner();
    }

    public String getScanResult() {
       return scanresult;
    }

    public void setCameraToUse(String frontOrBack) {
        mfrontOrBack = frontOrBack;
    }

    public void setSameCodeRescanProtectionTime(long sameCodeRescanProtectionTime) {
        cv.setSameCodeRescanProtectionTime(sameCodeRescanProtectionTime);
    }

//    public void setDecodeThrottleMillis(long throttle) {
//        cv.setDecodeThrottleMillis(throttle);
//    }

    public void setBackgroudImage(String draw) {
		 int DrawableID = BA.applicationContext.getResources().getIdentifier(draw, "drawable", BA.packageName);
                 cv.setHudImageResource(DrawableID);
    }
       



}
